// +FHDR------------------------------------------------------------
//                 Copyright (c) 2022 SmartLogic.
//                       ALL RIGHTS RESERVED
// -----------------------------------------------------------------
// Filename      : cpri_test_case0.c
// Author        : xianfeng.du
// Created On    : 2022-10-19s
// Last Modified :
// -----------------------------------------------------------------
// Description:
//
//
// -FHDR------------------------------------------------------------

#include "typedef.h"
#include "cpri_test.h"
#include "cpri_csu.h"
#include "ape_csu.h"
#include "hw_cpri.h"
#include "cpri_driver.h"
#include "ucp_utility.h"
#include "ucp_printf.h"
#include "cpri_timer.h"
#include "HeaderRam.h"
#include "hw_cpri.h"
#include "phy_para.h"
#include "cpri_csu_nr_7ds2u.h"

extern stMtimerIntStat 		gMtimerIntCnt[SCS_MAX_NUM];
extern uint32_t           Tdd_Offset_Int_Falg;
//extern uint32_t           CPRI_OPTION;
extern uint32_t gCpriTestMode;
extern stCpriCsuCmdFifoInfo txCmdFifo;
extern stCpriCsuCmdFifoInfo rxCmdFifo;

#define HeaderTestCnt   10

#define Ping_Flag   0
#define Pong_Flag   1

#define RF_NUM   1//2

uint32_t cpri_ape_csu_cnt = 0;

uint32_t cpri_AxC_test_cnt =0;

uint32_t cpri_AxC_test_cnt0 =0;
uint32_t cpri_AxC_test_cnt1 =0;

#define ID_NUM        6
#define ID0_SIZE      1
#define ID1_SIZE      8
#define ID2_SIZE      8
#define ID3_SIZE      8
#define ID4_SIZE      8
#define ID5_SIZE      1

int32_t fh_data_init(void)
{
	gCpriTestMode = CPRI_TEST_MODE;
	gCpriCsuDummyFlag  = 1;
	debug_write((DBG_DDR_IDX_DRV_BASE+192), gCpriTestMode); // 0x300

//	Get_Cpri_OptionId();//get cpri option value
//	debug_write((DBG_DDR_IDX_DRV_BASE+193), CPRI_OPTION); // 0x304
		
	Axc_data_init();//init axc data
	UCP_PRINT_EMPTY("Axc data init.\r\n");
	HeaderTxRam_data_init();
	//HeaderTxRam_init();

	return 0;
}

int32_t fh_drv_init(void)
{
	cpri_init(CPRI_OPTION_8, OTIC_MAP_FIGURE12);

	return 0;
}

int32_t fh_csu_test_init(void)
{
	stCpriCsuCmdFifoInfo		txTestCmdFifo;
	stCpriCsuCmdFifoInfo		rxTestCmdFifo;
	
	cpri_csu_axc_init_nr_7ds2u(CPRI_DUMMY_USE_DDR_ADDR, &txTestCmdFifo, &rxTestCmdFifo);
	cpri_csu_axcctrl_init_timing();
	UCP_API_CPRI_CSU_Get_CmdFIFO(&txTestCmdFifo, &rxTestCmdFifo);

	return 0;
}

void fh_test_case()
{
	UCP_API_CPRI_CSU_START(txCmdFifo, rxCmdFifo);
}


#if 1
void Axc_data_init()

{

   uint32_t i,j,k,t,m,n =0;
	
	 for(i=0;i<RF_NUM;i=i+1)//2 frame
	 {
		 for(j=0;j<2;j=j+1)//0-74HF/75-149HF
		 {
			for(k=0;k<ID_NUM;k=k+1)//ID
			{
				//bit31:28为RFN,bit27:20为HFN,bit19:12为BasicFN,bit11:8为AXC ID,bit7:0为AXC data
				if(0==k || 5==k)
				{
					for(t=0;t<75;t=t+1)//HF
				   {	
				  		for(m=0;m<256;m=m+1)//bfn
			  			{
			  				for(n=0;n<ID0_SIZE;n=n+1)//
		  					{		  	
					   			//STORE_EX_W(((uint32_t *)(CSU_TX_AXC_ADDR +ID_NUM*2*ID_DATA_STEP+ i*ID_DATA_STEP*ID_NUM*2 + j*ID_DATA_STEP*ID_NUM + k*ID_DATA_STEP + t*256*ID0_SIZE*4 + m*ID0_SIZE*4 + n*4)), (i<<28)+((j*75+t)<<20)+(m<<12)+(k<<8)+0x1);
								do_write(((uint32_t *)(CSU_TX_AXC_ADDR + i*ID_DATA_STEP*ID_NUM*2 + j*ID_DATA_STEP*ID_NUM + k*ID_DATA_STEP + t*256*ID0_SIZE*4 + m*ID0_SIZE*4 + n*4)), (i<<28)+((j*75+t)<<20)+(m<<12)+(k<<8)+0x1);

							}
				  		}

				   }

				}
				else//ID1~ID4
				{
					for(t=0;t<75;t=t+1)//HF
					{
						 for(m=0;m<256;m=m+1)//bfn
						 {
							 for(n=0;n<ID1_SIZE*8/4;n=n+1)//
							 {
								// STORE_EX_W(((uint32_t *)(CSU_TX_AXC_ADDR +ID_NUM*2*ID_DATA_STEP+ i*ID_DATA_STEP*ID_NUM*2 + j*ID_DATA_STEP*ID_NUM + k*ID_DATA_STEP + t*256*ID1_SIZE*8 + m*(ID1_SIZE*8) + n*4)), (i<<28)+((j*75+t)<<20)+(m<<12)+(k<<8)+n);
								 do_write(((uint32_t *)(CSU_TX_AXC_ADDR + i*ID_DATA_STEP*ID_NUM*2 + j*ID_DATA_STEP*ID_NUM + k*ID_DATA_STEP + t*256*ID1_SIZE*8 + m*(ID1_SIZE*8) + n*4)), (i<<28)+((j*75+t)<<20)+(m<<12)+(k<<8)+n);
					
							 }
					
							 
						 }
					
					}


				}
			}
		 }
		 
	 }

}

#endif


void CtrlAxc_data_init()
{
	uint32_t bf_ctrlaxc_byte = 16;

	for(uint32_t HFid=0;HFid<150;HFid++)
	{
		for(uint32_t BFid=0;BFid<16;BFid++)//4~7,68~71,132~135,196~199
		{
			for(uint32_t idvalue=0;idvalue<(bf_ctrlaxc_byte>>2);idvalue++)
			{

				do_write((uint32_t *)(CSU_TX_CTRL_ADDR+(idvalue<<2)+(BFid*16)+(HFid*256)),  ((HFid<<24) | (BFid<<8) | idvalue));
			}
		
		}

	}


}

void HeaderTxRam_data_init()
{

	for(int i=0;i<16*HeaderTestCnt;i++)
	{
		do_write(((uint32_t *)HeaderTxDataAddr0 +i),0x12345678+i);
	}
#if 0
	for(int i=0;i<16*HeaderTestCnt;i++)
	{
		do_write(((uint32_t *)HeaderTxDataAddr1 +i),0x87654321+i);
	}
#endif
}


uint32_t CtrlAxCDataErrorCnt= 0;
uint32_t CtrlAxCDataCheckCnt= 0;
uint32_t CtrlAxCDataCheckCycle= 0;
void fh_data_check(uint32_t times)
{
	stMtimerIntStat* pMtimerInt = &gMtimerIntCnt[MTIMER_CPRI_ID];
#if 1	
	uint32_t bf_ctrlaxc_byte = 16;
	uint32_t TxData , RxData= 0;
	CtrlAxCDataCheckCnt++;
	//if(pMtimerInt->tddOffsetIntCnt  >= 64)
	if (4 <= pMtimerInt->csuEnCnt)
	{

		for(uint32_t HFid=0;HFid<150;HFid++)
		{
			for(uint32_t BFid=0;BFid<16;BFid++)//4~7,68~71,132~135,196~199
			{
				for(uint32_t idvalue=0;idvalue<(bf_ctrlaxc_byte>>2);idvalue++)
				{
				    TxData = ((HFid<<24) | (BFid<<8) | idvalue);
					RxData = do_read_volatile((CSU_RX_CTRL_ADDR+(idvalue<<2)+(BFid*16)+(HFid*256)));
					if(TxData != RxData)
					{
					    CtrlAxCDataErrorCnt++;
						
						debug_write((DBG_DDR_IDX_CPRI_BASE+8+ ((CtrlAxCDataErrorCnt<<2)&0xff)), TxData); // 0xb7e28020 
						debug_write((DBG_DDR_IDX_CPRI_BASE+9+ ((CtrlAxCDataErrorCnt<<2)&0xff)), RxData); // 
						debug_write((DBG_DDR_IDX_CPRI_BASE+10+((CtrlAxCDataErrorCnt<<2)&0xff)),((HFid<<24) | (BFid<<8) | idvalue)); // 
					}
				}
			
			}
	
		}
		
		debug_write((DBG_DDR_IDX_CPRI_BASE+4), CtrlAxCDataCheckCnt); // 0xb7e28010
		debug_write((DBG_DDR_IDX_CPRI_BASE+5), CtrlAxCDataCheckCycle);
		debug_write((DBG_DDR_IDX_CPRI_BASE+6), CtrlAxCDataErrorCnt); // 
		if(CtrlAxCDataCheckCnt == 0xffffffff)
		{
			CtrlAxCDataCheckCycle++;
			CtrlAxCDataCheckCnt =0;
		}
	}
#endif
	return;

}

void cpri_csu_test_init()
{
	stCpriCsuCmdFifoInfo		txTestCmdFifo;
	stCpriCsuCmdFifoInfo		rxTestCmdFifo;
	
	cpri_csu_axc_init_nr_7ds2u(CPRI_DUMMY_USE_DDR_ADDR, &txTestCmdFifo, &rxTestCmdFifo);
	cpri_csu_axcctrl_init_timing();
	UCP_API_CPRI_CSU_Get_CmdFIFO(&txTestCmdFifo, &rxTestCmdFifo);
}


void Get_Cpri_OptionId()
{
	//CPRI_OPTION = CPRI_OPTION_8;
    return;
}

void Cpri_data_init()
{
	gCpriTestMode = CPRI_TEST_MODE;
	debug_write((DBG_DDR_IDX_DRV_BASE+192), gCpriTestMode); // 0x300
	Get_Cpri_OptionId();//get cpri option value
	UCP_PRINT_EMPTY("Get Cpri Option Id.\r\n");
		
	Axc_data_init();//init axc data
	CtrlAxc_data_init();
	//AUX_Rx_init(0x50000000,0x60000000,0x10000,0x10000);
	HeaderTxRam_data_init();
	//HeaderTxRam_init();			
	UCP_PRINT_EMPTY("Axc data init.\r\n");

}

int32_t fh_drv_init(void)
{
	cpri_init(CPRI_OPTION_8, OTIC_MAP_FIGURE12);

	return 0;
}

void cpri_AxCData_test(void)
{				
		stMtimerIntStat* pMtimerInt = &gMtimerIntCnt[MTIMER_CPRI_ID];
		if ((2 < pMtimerInt->tddOffsetIntCnt) &&(pMtimerInt->tddOffsetIntCnt < 7))//2 RF
		{				
			if (pMtimerInt->tddOffsetIntCnt&0x1)//ping
			{
			
				uint32_t startTick0 = GET_STC_CNT();
				
				ape_csu_dma_1D_G2L_ch2ch3_transfer(CSU_RX_AXC_ADDR,
												   CSU_RX_AXC_ADDR+ID_NUM*2*ID_DATA_STEP+(pMtimerInt->tddOffsetIntCnt-3)*ID_DATA_STEP*ID_NUM,
												   ID_DATA_STEP*ID_NUM, 0,1);										
					
				uint32_t cost0 = GET_STC_CNT() - startTick0;
				debug_write((DBG_DDR_IDX_CPRI_BASE+pMtimerInt->tddOffsetIntCnt),cost0);
							   
			}
			else//pong
			{
				uint32_t startTick1 = GET_STC_CNT();
				
				ape_csu_dma_1D_G2L_ch2ch3_transfer(CSU_RX_AXC_ADDR+ID_NUM*ID_DATA_STEP ,
												   CSU_RX_AXC_ADDR+ID_NUM*2*ID_DATA_STEP+(pMtimerInt->tddOffsetIntCnt-3)*ID_DATA_STEP*ID_NUM,
												   ID_DATA_STEP*ID_NUM, 1, 1);	
				
				uint32_t cost1 = GET_STC_CNT() - startTick1;
				debug_write((DBG_DDR_IDX_CPRI_BASE+pMtimerInt->tddOffsetIntCnt),cost1);
				
			}
		}
	

}


void cpri_test_case(void)
{

	stMtimerIntStat* pMtimerInt = &gMtimerIntCnt[MTIMER_CPRI_ID];
	//if(gCpriTimerPara.tddOffsetIntCnt <= 8)
	if(pMtimerInt->csuEnCnt > 4 )
	{
		if((pMtimerInt->csuEnCnt  &  0x3) == 0)
		{
			debug_write((DBG_DDR_IDX_CPRI_BASE+7), pMtimerInt->tddOffsetIntCnt); // 
			cpri_csu_start_timing();
		}
	}
			
}

void Cpri_Header_Rx(void)
{
}
